

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.19. grn_obj &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.25.20. grn_proc" href="grn_proc.html" />
    <link rel="prev" title="7.25.18. grn_match_escalation" href="grn_match_escalation.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/api/grn_obj.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="grn_proc.html" title="7.25.20. grn_proc"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="grn_match_escalation.html" title="7.25.18. grn_match_escalation"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.19. </span><code class="docutils literal notranslate"><span class="pre">grn_obj</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-obj">
<h1><span class="section-number">7.25.19. </span><code class="docutils literal notranslate"><span class="pre">grn_obj</span></code><a class="headerlink" href="#grn-obj" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.19.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.19.2. </span>Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.19.3. </span>Reference<a class="headerlink" href="#reference" title="Permalink to this headline">¶</a></h2>
<dl class="c type">
<dt id="c.grn_obj">
<em class="property">type </em><code class="sig-name descname">grn_obj</code><a class="headerlink" href="#c.grn_obj" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>TODO…</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_column">
<a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_obj_column</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> char *<em>name</em>, unsigned int <em>name_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_column" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>nameがカラム名の場合、それに対応するtableのカラムを返します。対応するカラムが存在しなければNULLを返します。</p>
<p>nameがアクセサ文字列の場合、それに対応するaccessorを返します。アクセサ文字列とは、カラム名等を’.’で連結した文字列です。’_id’, ‘_key’は特殊なアクセサで、それぞれレコードID/keyを返します。例) ‘col1’ / ‘col2.col3’ / ‘col2._id’</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>name</strong> – カラム名を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_is_builtin">
grn_bool <code class="sig-name descname">grn_obj_is_builtin</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_is_builtin" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Check whether Groonga built-in object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – context</p></li>
<li><p><strong>obj</strong> – target object</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_TRUE</span></code> for built-in groonga object, <code class="docutils literal notranslate"><span class="pre">GRN_FALSE</span></code> otherwise.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_is_index_column">
grn_bool <code class="sig-name descname">grn_obj_is_index_column</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_is_index_column" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Check whether index column.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object.</p></li>
<li><p><strong>obj</strong> – The target object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_TRUE</span></code> for if the target object is index column, <code class="docutils literal notranslate"><span class="pre">GRN_FALSE</span></code> otherwise. Even if the target object isn’t column, return <code class="docutils literal notranslate"><span class="pre">GRN_FALSE</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_is_vector_column">
grn_bool <code class="sig-name descname">grn_obj_is_vector_column</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_is_vector_column" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Check whether vector column.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object.</p></li>
<li><p><strong>obj</strong> – The target object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_TRUE</span></code> for if the target object is vector column, <code class="docutils literal notranslate"><span class="pre">GRN_FALSE</span></code> otherwise. Even if the target object isn’t column, return <code class="docutils literal notranslate"><span class="pre">GRN_FALSE</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_get_value">
<a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_obj_get_value</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, grn_id <em>id</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>value</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_get_value" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objのIDに対応するレコードのvalueを取得します。valueを戻り値として返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
<li><p><strong>id</strong> – 対象レコードのIDを指定します。</p></li>
<li><p><strong>value</strong> – 値を格納するバッファ（呼出側で準備する）を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_get_values">
int <code class="sig-name descname">grn_obj_get_values</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, grn_id <em>offset</em>, void **<em>values</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_get_values" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objに指定されたカラムについて、offsetに指定されたレコードIDを開始位置として、IDが連続するレコードに対応するカラム値が昇順に格納された配列へのポインタをvaluesにセットします。</p>
<p>取得できた件数が戻り値として返されます。エラーが発生した場合は -1 が返されます。</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>値が固定長であるカラムのみがobjに指定できます。範囲内のIDに対応するレコードが有効であるとは限りません。delete操作を実行したことのあるテーブルに対しては、<a class="reference internal" href="grn_table.html#c.grn_table_at" title="grn_table_at"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_table_at()</span></code></a> などによって各レコードの存否を別途確認しなければなりません。</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
<li><p><strong>offset</strong> – 値を取得する範囲の開始位置となるレコードIDを指定します。</p></li>
<li><p><strong>values</strong> – 値の配列がセットされます。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_set_value">
grn_rc <code class="sig-name descname">grn_obj_set_value</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, grn_id <em>id</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>value</em>, int <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_set_value" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objのIDに対応するレコードの値を更新します。対応するレコードが存在しない場合は <code class="docutils literal notranslate"><span class="pre">GRN_INVALID_ARGUMENT</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
<li><p><strong>id</strong> – 対象レコードのIDを指定します。</p></li>
<li><p><strong>value</strong> – 格納する値を指定します。</p></li>
<li><p><strong>flags</strong> – <p>以下の値を指定できます。</p>
<table class="hlist"><tr><td><ul>
<li><p><a class="reference internal" href="#c.GRN_OBJ_SET" title="GRN_OBJ_SET"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_SET</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.GRN_OBJ_INCR" title="GRN_OBJ_INCR"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_INCR</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.GRN_OBJ_DECR" title="GRN_OBJ_DECR"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_DECR</span></code></a></p></li>
</ul>
</td><td><ul>
<li><p><a class="reference internal" href="#c.GRN_OBJ_APPEND" title="GRN_OBJ_APPEND"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_APPEND</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.GRN_OBJ_PREPEND" title="GRN_OBJ_PREPEND"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_PREPEND</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.GRN_OBJ_GET" title="GRN_OBJ_GET"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_GET</span></code></a></p></li>
</ul>
</td><td><ul>
<li><p><a class="reference internal" href="#c.GRN_OBJ_COMPARE" title="GRN_OBJ_COMPARE"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_COMPARE</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.GRN_OBJ_LOCK" title="GRN_OBJ_LOCK"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_LOCK</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.GRN_OBJ_UNLOCK" title="GRN_OBJ_UNLOCK"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_UNLOCK</span></code></a></p></li>
</ul>
</td></tr></table>
</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_SET_MASK">
<code class="sig-name descname">GRN_OBJ_SET_MASK</code><a class="headerlink" href="#c.GRN_OBJ_SET_MASK" title="Permalink to this definition">¶</a><br /></dt>
<dd></dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_SET">
<code class="sig-name descname">GRN_OBJ_SET</code><a class="headerlink" href="#c.GRN_OBJ_SET" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>レコードの値をvalueと置き換えます。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_INCR">
<code class="sig-name descname">GRN_OBJ_INCR</code><a class="headerlink" href="#c.GRN_OBJ_INCR" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>レコードの値にvalueを加算します。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_DECR">
<code class="sig-name descname">GRN_OBJ_DECR</code><a class="headerlink" href="#c.GRN_OBJ_DECR" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>レコードの値にvalueを減算します。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_APPEND">
<code class="sig-name descname">GRN_OBJ_APPEND</code><a class="headerlink" href="#c.GRN_OBJ_APPEND" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>レコードの値の末尾にvalueを追加します。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_PREPEND">
<code class="sig-name descname">GRN_OBJ_PREPEND</code><a class="headerlink" href="#c.GRN_OBJ_PREPEND" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>レコードの値の先頭にvalueを追加します。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_GET">
<code class="sig-name descname">GRN_OBJ_GET</code><a class="headerlink" href="#c.GRN_OBJ_GET" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>新しいレコードの値をvalueにセットします。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_COMPARE">
<code class="sig-name descname">GRN_OBJ_COMPARE</code><a class="headerlink" href="#c.GRN_OBJ_COMPARE" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>レコードの値とvalueが等しいか調べます。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_LOCK">
<code class="sig-name descname">GRN_OBJ_LOCK</code><a class="headerlink" href="#c.GRN_OBJ_LOCK" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>当該レコードをロックします。<a class="reference internal" href="#c.GRN_OBJ_COMPARE" title="GRN_OBJ_COMPARE"><code class="xref c c-macro docutils literal notranslate"><span class="pre">GRN_OBJ_COMPARE</span></code></a> と共に指定された場合は、レコードの値とvalueが等しい場合に限ってロックします。</p>
</dd></dl>

<dl class="c macro">
<dt id="c.GRN_OBJ_UNLOCK">
<code class="sig-name descname">GRN_OBJ_UNLOCK</code><a class="headerlink" href="#c.GRN_OBJ_UNLOCK" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>当該レコードのロックを解除します。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_remove">
grn_rc <code class="sig-name descname">grn_obj_remove</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_remove" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objをメモリから解放し、それが永続オブジェクトであった場合は、該当するファイル一式を削除します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_rename">
grn_rc <code class="sig-name descname">grn_obj_rename</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, <em class="property">const</em> char *<em>name</em>, unsigned int <em>name_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_rename" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>ctxが使用するdbにおいてobjに対応する名前をnameに更新します。objは永続オブジェクトでなければいけません。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
<li><p><strong>name</strong> – 新しい名前を指定します。</p></li>
<li><p><strong>name_size</strong> – nameパラメータのsize（byte）を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_close">
grn_rc <code class="sig-name descname">grn_obj_close</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_close" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>一時的なobjectであるobjをメモリから解放します。objに属するobjectも再帰的にメモリから解放されます。</p>
<p>永続的な、table, column, exprなどは解放してはいけません。一般的には、一時的か永続的かを気にしなくてよい <a class="reference internal" href="#c.grn_obj_unlink" title="grn_obj_unlink"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_obj_unlink()</span></code></a> を用いるべきです。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_reinit">
grn_rc <code class="sig-name descname">grn_obj_reinit</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, grn_id <em>domain</em>, unsigned char <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_reinit" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objの型を変更します。</p>
<p>objは <code class="xref c c-func docutils literal notranslate"><span class="pre">GRN_OBJ_INIT()</span></code> マクロなどで初期化済みでなければいけません。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
<li><p><strong>domain</strong> – 変更後のobjの型を指定します。</p></li>
<li><p><strong>flags</strong> – <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_VECTOR</span></code> を指定するとdomain型の値のベクタを格納するオブジェクトになります。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_unlink">
void <code class="sig-name descname">grn_obj_unlink</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_unlink" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objをメモリから解放します。objに属するobjectも再帰的にメモリから解放されます。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_path">
<em class="property">const</em> char *<code class="sig-name descname">grn_obj_path</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_path" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objに対応するファイルパスを返します。一時objectならNULLを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_name">
int <code class="sig-name descname">grn_obj_name</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, char *<em>namebuf</em>, int <em>buf_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_name" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objの名前の長さを返します。無名objectなら0を返します。</p>
<p>名前付きのobjectであり、buf_sizeの長さが名前の長以上であった場合は、namebufに該当する名前をコピーします。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
<li><p><strong>namebuf</strong> – 名前を格納するバッファ（呼出側で準備する）を指定します。</p></li>
<li><p><strong>buf_size</strong> – namebufのサイズ（byte長）を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_get_range">
grn_id <code class="sig-name descname">grn_obj_get_range</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_get_range" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objパラメータのとる値の範囲を表わしているオブジェクトのIDを返します。例えば、<a class="reference internal" href="grn_type.html#c.grn_builtin_type" title="grn_builtin_type"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_builtin_type</span></code></a> にある <code class="docutils literal notranslate"><span class="pre">GRN_DB_INT</span></code> などを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_expire">
int <code class="sig-name descname">grn_obj_expire</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, int <em>threshold</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_expire" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objの占有するメモリのうち、可能な領域をthresholdを指標として解放します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_check">
int <code class="sig-name descname">grn_obj_check</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_check" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objに対応するファイルの整合性を検査します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_lock">
grn_rc <code class="sig-name descname">grn_obj_lock</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, grn_id <em>id</em>, int <em>timeout</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_lock" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objをlockします。timeout（秒）経過してもlockを取得できない場合は <code class="docutils literal notranslate"><span class="pre">GRN_RESOURCE_DEADLOCK_AVOIDED</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_unlock">
grn_rc <code class="sig-name descname">grn_obj_unlock</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, grn_id <em>id</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_unlock" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objをunlockします。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_clear_lock">
grn_rc <code class="sig-name descname">grn_obj_clear_lock</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_clear_lock" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>強制的にロックをクリアします。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_is_locked">
unsigned int <code class="sig-name descname">grn_obj_is_locked</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_is_locked" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objが現在lockされていれば0以外の値を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_defrag">
int <code class="sig-name descname">grn_obj_defrag</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, int <em>threshold</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_defrag" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objの占有するDBファイル領域のうち、可能な領域をthresholdを指標としてフラグメントの解消を行います。</p>
<p>フラグメント解消が実行されたセグメントの数を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_id">
grn_id <code class="sig-name descname">grn_obj_id</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_id" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>objのidを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>obj</strong> – 対象objectを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_delete_by_id">
grn_rc <code class="sig-name descname">grn_obj_delete_by_id</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em>, grn_id <em>id</em>, grn_bool <em>removep</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_delete_by_id" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>dbからidに対応するテーブルやカラムなどを削除します。mroonga向けに用意した内部APIです。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> – The target database.</p></li>
<li><p><strong>id</strong> – The object (table, column and so on) ID to be deleted.</p></li>
<li><p><strong>removep</strong> – If <code class="docutils literal notranslate"><span class="pre">GRN_TRUE</span></code>, clear object cache and remove relation between ID and key in database. Otherwise, just clear object cache.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_path_by_id">
grn_rc <code class="sig-name descname">grn_obj_path_by_id</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>db</em>, grn_id <em>id</em>, char *<em>buffer</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_path_by_id" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>dbのidに対応するpathを返します。mroonga向けに用意した内部APIです。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>db</strong> – The target database.</p></li>
<li><p><strong>id</strong> – The object (table, column and so on) ID to be deleted.</p></li>
<li><p><strong>buffer</strong> – path string corresponding to the id will be set in this buffer.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_obj_cast_by_id">
grn_rc <code class="sig-name descname">grn_obj_cast_by_id</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>source</em>, <a class="reference internal" href="#c.grn_obj" title="grn_obj">grn_obj</a> *<em>destination</em>, grn_bool <em>add_record_if_not_exist</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_obj_cast_by_id" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>It casts value of <code class="docutils literal notranslate"><span class="pre">source</span></code> to value with type of
<code class="docutils literal notranslate"><span class="pre">destination</span></code>. Casted value is appended to <code class="docutils literal notranslate"><span class="pre">destination</span></code>.</p>
<p>Both <code class="docutils literal notranslate"><span class="pre">source</span></code> and <code class="docutils literal notranslate"><span class="pre">destination</span></code> must be bulk.</p>
<p>If <code class="docutils literal notranslate"><span class="pre">destination</span></code> is a reference type bulk. (Reference type bulk
means that type of <code class="docutils literal notranslate"><span class="pre">destination</span></code> is a table.)
<code class="docutils literal notranslate"><span class="pre">add_record_if_not_exist</span></code> is used. If <code class="docutils literal notranslate"><span class="pre">source</span></code> value doesn’t
exist in the table that is a type of <code class="docutils literal notranslate"><span class="pre">destination</span></code>. The <code class="docutils literal notranslate"><span class="pre">source</span></code>
value is added to the table.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object.</p></li>
<li><p><strong>source</strong> – The bulk to be casted.</p></li>
<li><p><strong>destination</strong> – The bulk to specify cast target type and store
casted value.</p></li>
<li><p><strong>add_record_if_not_exist</strong> – Whether adding a new record if
<code class="docutils literal notranslate"><span class="pre">source</span></code> value doesn’t exist in
cast target table. This parameter
is only used when <code class="docutils literal notranslate"><span class="pre">destination</span></code>
is a reference type bulk.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on success, not <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on error.</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.19. <code class="docutils literal notranslate"><span class="pre">grn_obj</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.19.1. Summary</a></li>
<li><a class="reference internal" href="#example">7.25.19.2. Example</a></li>
<li><a class="reference internal" href="#reference">7.25.19.3. Reference</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="grn_match_escalation.html"
                        title="previous chapter"><span class="section-number">7.25.18. </span><code class="docutils literal notranslate"><span class="pre">grn_match_escalation</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="grn_proc.html"
                        title="next chapter"><span class="section-number">7.25.20. </span><code class="docutils literal notranslate"><span class="pre">grn_proc</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="grn_proc.html" title="7.25.20. grn_proc"
             >next</a> |</li>
        <li class="right" >
          <a href="grn_match_escalation.html" title="7.25.18. grn_match_escalation"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.19. </span><code class="docutils literal notranslate"><span class="pre">grn_obj</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>